%global pkg irdma
%global kernel 5.10.134-17.an8
%define pkg_version 1.13.43
%define anolis_release 1

Name:		kmod-%{pkg}
Version:	%(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:	%{pkg_version}~%{anolis_release}%{?dist}
Summary:	irdma driver
License:	GPLv2
Group:		System Environment/Kernel
Source:		kmod-%{pkg}-%{pkg_version}.tar.gz


BuildRequires: rdma-core
BuildRequires: python3-docutils perl-generators python3-Cython python3-devel
BuildRequires: bash cmake gcc libnl3-devel libudev-devel make pkgconfig valgrind-devel
BuildRequires: kernel = %{kernel} 
BuildRequires: kernel-devel = %{kernel} 

Requires: kmod-ice
Requires:            kernel >= %{kernel}
Requires(post):		    %{_sbindir}/weak-modules
Requires(post):		    %{_sbindir}/depmod 
Requires(postun):       %{_sbindir}/depmod 
Requires(postun):	    %{_sbindir}/weak-modules
Requires(posttrans):    %{_bindir}/sort
Requires(postun):       %{_bindir}/sort

ExclusiveArch: x86_64 aarch64
%define debug_package %{nil}

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
Suitable for E810 and X722 Intel ®  Linux * RDMA Driver for Ethernet Controller

# prep #########################################################################
%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

# build ########################################################################
%build
export KSRC=/usr/src/kernels/%{kernel}.%{_arch}
export BUILD_KERNEL=%{kernel}.%{_arch}
bash build.sh noinstall

# install ######################################################################
%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/irdma/
find src -name *.ko | while read line
do
	cp $line %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/irdma/
done

# install的该段需要保留，weak-module相关
# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/irdma/%{pkg}.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
echo "/lib/modules/%{kernel}.%{_arch}/extra/irdma/%{pkg}.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list


# files ########################################################################
%files
/lib/modules/%{kernel}.%{_arch}/extra/irdma/irdma.ko
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

# changelog  ###################################################################
%changelog
* Sun Jul 7 2024 Kaiqiang Wang <wangkaiqiang@inspur.com> - 1.13.43-1
- add irema driver
